/* File: "os.h", Time-stamp: <2005-01-04 10:47:50 feeley> */

/* Copyright (C) 1994-2005 by Marc Feeley, All Rights Reserved. */

#ifndef ___OS_H
#define ___OS_H


/*---------------------------------------------------------------------------*/

/* Include the header files that are available. */


#ifdef _WIN32

#define USE_WIN32

#else

#define USE_POSIX

#endif


/*---------------------------------------------------------------------------*/

#define ___DEBUG_not
#define ___DEBUG_TTY_not
#define ___DEBUG_ALLOC_MEM_TRACE_not


#define USE_LINEEDITOR
#define LINEEDITOR_WITH_NONBLOCKING_IO
#define LINEEDITOR_SUPPORT_F5_TO_F12
#define LINEEDITOR_WITH_LOCAL_CLIPBOARD
#define LINEEDITOR_REPORT_CHAR_ENCODING_ERRORS


#ifdef USE_WIN32

#define HAVE_GETSYSTEMTIME 1

#define USE_GetSystemTime
#define USE_LoadLibrary
#define USE_CreateThread
#define USE_GetProcessTimes
#define USE_MsgWaitForMultipleObjects
#define USE_gethostbyname
#define USE_ioctl

#define USE_CURSES

#include <tchar.h>

#endif


#ifdef USE_POSIX

#define USE_POSIX /* temporary */
//#define USE_WIN32
#define USE_TERMCAPzzz
#define USE_TERMCAP_OR_TERMINFOzzz
#include <curses.h>

#endif



#ifdef USE_WIN32

#define USE_errno
///#define USE_h_errno
#define USE_strerror
///#define USE_hstrerror
#define USE_GetLastError
#define USE_WSAGetLastError

#endif

#ifdef USE_POSIX

#define USE_errno
#define USE_h_errno
#define USE_strerror
#define USE_hstrerror

#endif

#ifdef USE_CLASSIC_MACOS

#define USE_OSErr

#endif



#include <stdio.h> /* temporary */

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef HAVE_SYS_TIMES_H
#include <sys/times.h>
#endif

#ifdef HAVE_SYS_TIMEB_H
#include <sys/timeb.h>
#endif

#ifdef HAVE_SYS_TIMERS_H
#include <sys/timers.h>
#endif

#ifdef HAVE_SYS_RESOURCE_H
#include <sys/resource.h>
#endif

#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif

#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif

#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#ifdef HAVE_SYS_FPU_H
#include <sys/fpu.h>
#endif

#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

#ifdef HAVE_DIRENT_H
#include <dirent.h>
#endif

#ifdef HAVE_PWD_H
#include <pwd.h>
#endif

#ifdef HAVE_GRP_H
#include <grp.h>
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif

#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#ifdef HAVE_DLFCN_H
#include <dlfcn.h>
#endif

#ifdef HAVE_DL_H
#include <dl.h>
#endif

#ifdef HAVE_SYS_DXE_H
#include <sys/dxe.h>
#endif

#ifdef HAVE_MACH_O_DYLD_H
#include <mach-o/dyld.h>
#endif

#ifdef HAVE_TIME_H
#include <time.h>
#endif

#ifdef HAVE_SIGNAL_H
#include <signal.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_TERMIOS_H
#include <termios.h>
#endif

#ifdef HAVE_TERM_H
#include <term.h>
#endif

#ifdef HAVE_NCURSES_H
#include <ncurses.h>
#endif

#ifdef HAVE_CURSES_H
#include <curses.h>
#endif

#ifdef HAVE_PTY_H
#include <pty.h>
#endif

#ifdef HAVE_LIBUTIL_H
#include <libutil.h>
#endif

#ifdef HAVE_UTIL_H
#include <util.h>
#endif








#if 0
#include <stat.h>
#include <windows.h>
#include <io.h>
#include <float.h>
#include <fpu_control.h>
#include <os2.h>
#include <dos.h>
#include <direct.h>
#include <Retrace.h>
#include <Files.h>
#include <Finder.h>
#include <Errors.h>
#include <Folders.h>
#include <OSUtils.h>
#include <Power.h>
#include <CodeFragments.h>
#include <SIOUX.h>
#include "mac_gui.h"
#include <unix.h>
#include <wdefwin.h>
#include <tfork.h>
#include <util.h>
#endif

/*---------------------------------------------------------------------------*/

/* Determine which function for getting real time is most precise.  */

#ifdef HAVE_CLOCK_GETTIME
#define USE_clock_gettime
#else
#ifdef HAVE_GETCLOCK
#define USE_getclock
#else
#ifdef HAVE_GETSYSTEMTIME
#define USE_GetSystemTime
#else
#ifdef HAVE_GETTIMEOFDAY
#define USE_gettimeofday
#else
#ifdef HAVE_FTIME
#define USE_ftime
#else
#ifdef HAVE_TIME
#define USE_time
#endif
#endif
#endif
#endif
#endif
#endif

/* Determine which function for sleeping is most precise.  */

#ifdef HAVE_NANOSLEEP
#define USE_nanosleep
#else
#ifdef HAVE_Sleep
#define USE_Sleep
#else
#ifdef HAVE_SLEEP
#define USE_sleep
#endif
#endif
#endif

/* Determine which function for getting process time is most precise.  */

#ifdef HAVE_GETPROCESSTIMES
#define USE_GetProcessTimes
#else
#ifdef HAVE_GETRUSAGE
#define USE_getrusage
#else
#ifdef HAVE_TIMES
#define USE_times
#else
#ifdef HAVE_CLOCK
#define USE_clock
#else
#ifdef HAVE_DOSQUERYSYSINFO
#define USE_DosQuerySysInfo
#endif
#endif
#endif
#endif
#endif

#ifdef HAVE_SYSCONF
#define USE_sysconf
#endif

/* Determine which signal interface to use.  */

#ifdef HAVE_SIGACTION
#define USE_sigaction
#ifndef HAVE_SIGEMPTYSET
#undef USE_sigaction
#endif
#ifndef HAVE_SIGADDSET
#undef USE_sigaction
#endif
#ifndef HAVE_SIGPROCMASK
#undef USE_sigaction
#endif
#endif

#ifndef USE_sigaction
#ifdef HAVE_SIGNAL
#define USE_signal
#endif
#endif

/* Determine which dynamic loading interface to use.  */

#ifdef HAVE_SHL_LOAD
#define USE_shl_load
#else
#ifdef HAVE_LOADLIBRARY
#define USE_LoadLibrary
#else
#ifdef HAVE_DOSLOADMODULE
#define USE_DosLoadModule
#else
#ifdef HAVE_DXE_LOAD
#define USE_dxe_load
#else
#ifdef HAVE_GETDISKFRAGMENT
#define USE_GetDiskFragment
#else
#ifdef HAVE_NSLINKMODULE
#define USE_NSLinkModule
#else
#ifdef HAVE_DLOPEN
#define USE_dlopen
#endif
#endif
#endif
#endif
#endif
#endif
#endif

/*---------------------------------------------------------------------------*/



#ifdef HAVE_SETITIMER
#define USE_setitimer
#endif

#ifdef HAVE_GETHOSTBYNAME
#define USE_gethostbyname
#endif

#ifdef HAVE_GETSERVBYNAME
#define USE_getservbyname
#endif

#ifdef HAVE_GETSERVBYPORT
#define USE_getservbyport
#endif

#ifdef HAVE_GETPROTOBYNAME
#define USE_getprotobyname
#endif

#ifdef HAVE_GETPROTOBYNUMBER
#define USE_getprotobynumber
#endif

#ifdef HAVE_GETNETBYNAME
#define USE_getnetbyname
#endif


/*---------------------------------------------------------------------------*/

/* Determine which select interface to use.  */

/****temporary patch****/

#if 0
#ifndef HAVE_SELECT
#define HAVE_SELECT
#endif
#endif

#ifdef HAVE_SELECT
#define USE_select
#else
#ifdef HAVE_MSGWAITFORMULTIPLEOBJECTS
#define USE_MsgWaitForMultipleObjects
#endif
#endif

/*---------------------------------------------------------------------------*/

/* Determine which curses interface should be used.  */

#if 0
///////////////////////////////

#ifdef HAVE_TGETSTR
#define USE_TERMCAP
#define USE_CURSES
#else
#ifdef HAVE_TIGETSTR
#define USE_TERMINFO
#define USE_CURSES
#endif
#endif

#else

#define USE_CURSES

#endif

/*---------------------------------------------------------------------------*/

/* Determine which pty interface should be used.  */

#ifdef HAVE_OPENPTY
#define USE_openpty
#else
#ifdef HAVE_PTSNAME
#define USE_ptsname
#endif
#endif

/*---------------------------------------------------------------------------*/

#ifdef HAVE_HSTRERROR
#define USE_hstrerror
#endif

/*---------------------------------------------------------------------------*/



#if 0


#define xxxUSE_UNIX
#define xxxUSE_dlopen

#ifdef USE_sigaction
#define USE_sigaction_SIGINT
#endif

#ifdef USE_signal
#define USE_signal_SIGINT
#endif



#ifdef __linux__
#ifdef i386
#define USE__FPU_SETCW
#endif
#endif

#ifdef __DJGPP__
#ifdef __i386__
#define USE_DJGPP
#endif
#endif

#ifdef _MSC_VER
#ifndef __MWERKS__
#if _MSC_VER < 1000
#ifdef _M_I86
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#endif
#else
#ifdef _M_IX86
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#endif
#endif
#ifndef S_ISDIR
#define S_ISDIR(mode)(mode&_S_IFDIR)
#endif
#define popen(command,mode)_popen(command,mode)
#define pclose(stream)_pclose(stream)
#define isatty(descr)_isatty(descr)
#define USE_autocad_gui
#endif
#endif

#ifdef USE_autocad_gui
#define RTNORM  5100
#define RTCAN  -5002
extern int acedPrompt (const char *str);
extern int acedGetString (int cronly, const char *prompt, char *result);
extern int acedGetStringB (int cronly, const char *prompt,
                           char *result, int bufsize);
extern int acedUsrBrk (void);
extern int acedCommand (int rtype, ...);
#endif

#ifdef __BORLANDC__
#ifdef _M_IX86
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#define popen(command,mode)_popen(command,mode)
#define pclose(stream)_pclose(stream)
#endif
#endif

#ifdef __WATCOMC__
#ifdef __386__
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#ifdef __SW_BW
#define INCLUDE_wdefwin_h
#endif
#define popen(command,mode)_popen(command,mode)
#define pclose(stream)_pclose(stream)
#endif
#endif

#ifdef __MWERKS__
#ifdef __INTEL__
#define USE_WIN32
#define USE_time
#define fileno(stream)_fileno(stream)
#define isatty(descr)_isatty(descr)
#else
#define USE_MACOS
#define USE_GetDateTime
#define USE_TickCount
#define USE_CWIDE
#define EIO (EINTR+1)
#define BUFFERED_STDOUT
#if __MWERKS__ < 0x2000
#define kPrivateCFragCopy kNewCFragCopy
#endif
#if __MWERKS__ < 0x1800
#define USE_SIOUX
#else
#define USE_mac_gui
#endif
#endif
#define EINTR 9999
#define popen(command,mode) 0
#define pclose(stream) -1
#endif

#ifdef __MINGW32__
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#endif

#ifdef __MACHTEN__
#define USE_UNIX
#endif

#ifdef __MACH__
#ifdef __APPLE__
#ifdef __ppc__
#define USE_UNIX
#define USE_NSLinkModule
#define USE_sigaction_SIGINT
#define USE_sigaction_setitimer
#define USE_openpty
#define USE_gethostbyname
#endif
#endif
#endif

#ifdef __LCC__
#ifdef _X86_
#ifdef _M_IX86
#define USE_fullpath
#define USE_ftime
#ifndef S_ISDIR
#define S_ISDIR(mode)(mode&_S_IFDIR)
#endif
#endif
#endif
#endif

#ifdef _CRAY
#ifdef _CRAY1
#define USE_UNICOS
#endif
#endif

#endif /* #if 0 */

/*---------------------------------------------------------------------------*/

/* Determine which header files to include. */

#ifdef USE_UNIX
#define USE_getrusage
#define USE_gettimeofday
#define INCLUDE_unistd_h
#define INCLUDE_pwd_h
#define INCLUDE_grp_h
#define INCLUDE_sys_types_h
#define INCLUDE_sys_time_h
#define INCLUDE_time_h
#endif

#ifdef USE_DJGPP
#define USE_gettimeofday
#define USE_times
#define USE_DOS_PATHS
#define USE_dxe_load
#define USE_control87
#endif

#ifdef USE_WIN32
#define USE_clock
#define USE_DOS
#define USE_LoadLibrary
#define USE_signal_SIGINTXXXXXX
#define USE_CreateThread
#define INCLUDE_windows_h
#define INCLUDE_io_h
#define USE_control87XXXXXXX
#define USE_GetLastError /*XXXXXXX*/
#define USE_FormatMessage
#endif

#ifdef USE_OS2
#define USE_DOS
#define USE_fullpath
#define USE_DosStartTimer
#define USE_DosLoadModule
#define INCLUDE_sys_types_h
#define INCLUDE_sys_stat_h
#define INCLUDE_signal_h
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#define INCL_DOSFILEMGR
#define INCL_DOSMISC
#define INCL_DOSDATETIME
#define INCLUDE_os2_h
#endif

#ifdef USE_DOS
#define USE_DOS_PATHS
#ifndef USE_WIN32
#define INCLUDE_dos_h
#endif
#define INCLUDE_direct_h
#define INCLUDE_time_h
#endif

#ifdef USE_MACOS
#define USE_GetDiskFragment
#define USE_signal_SIGINT
#define USE_VInstall
#define INCLUDE_Retrace_h
#define INCLUDE_Files_h
#define INCLUDE_Finder_h
#define INCLUDE_Errors_h
#define INCLUDE_Folders_h
#define INCLUDE_OSUtils_h
#define INCLUDE_Power_h
#define INCLUDE_CodeFragments_h
#define INCLUDE_signal_h
#define INCLUDE_stat_h
#ifdef USE_SIOUX
#define INCLUDE_SIOUX_h
#define INCLUDE_unistd_h
#define INCLUDE_unix_h
#endif
#ifdef USE_mac_gui
#define INCLUDE_mac_gui_h
#endif
#endif

#ifdef USE_UNICOS
#define USE_gettimeofday
#define USE_times
#define USE_signal_SIGINT
#define USE_t_fork
#define INCLUDE_unistd_h
#define INCLUDE_sys_types_h
#define INCLUDE_sys_time_h
#define INCLUDE_time_h
#endif

/////////////////////////
#ifdef HAVE_SYS_FPU_H
#define INCLUDE_sys_fpu_h
#endif

#ifdef INCLUDE_sys_fpu_h
#include <sys/fpu.h>
#endif

/////////////////////////
#ifdef HAVE_FENV_H
#define INCLUDE_fenv_h
#endif

#ifdef INCLUDE_fenv_h
#include <fenv.h>
#endif





#ifdef USE_time
#define INCLUDE_time_h
#endif

#ifdef USE_ftime
#define INCLUDE_sys_types_h
#define INCLUDE_sys_timeb_h
#endif

#ifdef USE_gettimeofday
#define INCLUDE_sys_time_h
#endif

#ifdef USE_times
#define INCLUDE_sys_times_h
#endif

#ifdef USE_clock_gettime
#define INCLUDE_time_h
#endif

#ifdef USE_getclock
#define INCLUDE_sys_timers_h
#endif

#ifdef USE_getrusage
#define INCLUDE_sys_resource_h
#endif

#ifdef USE_dlopen
#define INCLUDE_dlfcn_h
#endif

#ifdef USE_shl_load
#define INCLUDE_dl_h
#endif

#ifdef USE_dxe_load
#define INCLUDE_sys_dxe_h
#endif

#ifdef USE_NSLinkModule
#define INCLUDE_mach_o_dyld_h
#endif

#ifdef USE_signal
#undef INCLUDE_signal_h
#define INCLUDE_signal_h
#endif

#ifdef USE_sigaction
#undef INCLUDE_signal_h
#define INCLUDE_signal_h
#endif

#ifdef USE_gethostbyname
#ifdef USE_WIN32
#else
#define INCLUDE_netdb_h
#endif
#endif

#ifdef USE_fullpath
#define INCLUDE_sys_stat_h
#endif

#ifdef USE_control87
#define INCLUDE_float_h
#endif

#ifdef USE__FPU_SETCW
#ifdef HAS_fpu_control_h
#define INCLUDE_fpu_control_h
#else
/*
 * Some Linux distributions don't have the file "fpu_control.h".
 * Instead of including that file we explicitly define the macros we
 * need.
 */
#ifndef _FPU_CONTROL_H
#define _FPU_CONTROL_H
#define _FPU_MASK_IM  0x01
#define _FPU_MASK_DM  0x02
#define _FPU_MASK_ZM  0x04
#define _FPU_MASK_OM  0x08
#define _FPU_MASK_UM  0x10
#define _FPU_MASK_PM  0x20
#define _FPU_DOUBLE   0x200
#define _FPU_RC_NEAREST 0x0
typedef unsigned int fpu_control_t __attribute__ ((__mode__ (__HI__)));
#define _FPU_SETCW(cw) __asm__ ("fldcw %0" : : "m" (*&cw))
#endif
#endif
#endif

#ifdef USE_t_fork
#define INCLUDE_tfork_h
#define INCLUDE_sys_wait_h
#endif

#ifdef USE_openpty
#ifdef HAVE_UTIL_H
#define INCLUDE_util_h
#endif
#endif


/*---------------------------------------------------------------------------*/

/* Inclusion of header files. */

#define _STDIO_UNLOCK_CHAR_IO

#include <stdio.h>
#include <errno.h>

#ifndef ESUCCESS
#define ESUCCESS 0
#endif

#ifndef EINTR
#define EINTR -1
#endif

#define __USE_XOPEN
#include <stdlib.h>

#include <string.h>

#ifdef INCLUDE_unistd_h
#include <unistd.h>
#endif

#ifdef INCLUDE_pwd_h
#include <pwd.h>
#endif

#ifdef INCLUDE_grp_h
#include <grp.h>
#endif

#ifdef INCLUDE_dlfcn_h
#include <dlfcn.h>
#endif

#ifdef INCLUDE_dl_h
#include <dl.h>
#endif

#ifdef INCLUDE_sys_dxe_h
#include <sys/dxe.h>
#endif

#ifdef INCLUDE_mach_o_dyld_h
#include <mach-o/dyld.h>
#endif

#ifdef INCLUDE_sys_types_h
#include <sys/types.h>
#endif

#ifdef INCLUDE_sys_time_h
#include <sys/time.h>
#endif

#ifdef INCLUDE_sys_times_h
#include <sys/times.h>
#endif

#ifdef INCLUDE_sys_timeb_h
#include <sys/timeb.h>
#endif

#ifdef INCLUDE_sys_timers_h
#include <sys/timers.h>
#endif

#ifdef INCLUDE_time_h
#include <time.h>
#endif

#ifdef INCLUDE_sys_resource_h
#include <sys/resource.h>
#endif

#ifdef INCLUDE_sys_stat_h
#include <sys/stat.h>
#endif

#ifdef INCLUDE_sys_wait_h
#include <sys/wait.h>
#endif

#ifdef INCLUDE_stat_h
#include <stat.h>
#endif

#ifdef INCLUDE_signal_h
#include <signal.h>
#endif

#ifdef INCLUDE_netdb_h
#include <netdb.h>
#endif

#ifdef INCLUDE_windows_h
#include <windows.h>
#endif

#ifdef INCLUDE_io_h
#include <io.h>
#endif

#ifdef INCLUDE_float_h
#include <float.h>
#endif

#ifdef INCLUDE_fpu_control_h
#include <fpu_control.h>
#endif

#ifdef INCLUDE_os2_h
#include <os2.h>
#endif

#ifdef INCLUDE_dos_h
#include <dos.h>
#endif

#ifdef INCLUDE_direct_h
#include <direct.h>
#endif

#ifdef INCLUDE_Retrace_h
#include <Retrace.h>
#endif

#ifdef INCLUDE_Files_h
#include <Files.h>
#endif

#ifdef INCLUDE_Finder_h
#include <Finder.h>
#endif

#ifdef INCLUDE_Errors_h
#include <Errors.h>
#endif

#ifdef INCLUDE_Folders_h
#include <Folders.h>
#endif

#ifdef INCLUDE_OSUtils_h
#include <OSUtils.h>
#endif

#ifdef INCLUDE_Power_h
#include <Power.h>
#endif

#ifdef INCLUDE_CodeFragments_h
#include <CodeFragments.h>
#endif

#ifdef INCLUDE_SIOUX_h
#include <SIOUX.h>
#endif

#ifdef INCLUDE_mac_gui_h
#include "mac_gui.h"
#endif

#ifdef INCLUDE_unix_h
#include <unix.h>
#endif

#ifdef INCLUDE_wdefwin_h
#include <wdefwin.h>
#endif

#ifdef INCLUDE_tfork_h
#include <tfork.h>
#endif

#ifdef INCLUDE_util_h
#include <util.h>
#endif




#define ___CHAR_TYPE(ce) \
ce(___LATIN1,char,___UCS2,___UCS4,char)

#define ___STRING_TYPE(ce) \
ce(___LATIN1STRING,___UTF8STRING,___UCS2STRING,___UCS4STRING,char*)

#define ___CE(ce) \
ce(___CHAR_ENCODING_LATIN1, \
   ___CHAR_ENCODING_UTF8, \
   ___CHAR_ENCODING_UCS2, \
   ___CHAR_ENCODING_UCS4, \
   ___CHAR_ENCODING_NATIVE)


extern void ___disable_os_interrupts ___PVOID;
extern void ___enable_os_interrupts ___PVOID;

/*---------------------------------------------------------------------------*/

/* Virtual memory statistics. */

extern void ___vm_stats
   ___P((long *minflt,
         long *majflt),
        ());


/* Formatting of source code position. */

extern char *___format_filepos
   ___P((char *path,
         long filepos,
         ___BOOL pinpoint),
        ());


/* OS initialization/finalization. */

extern ___SCMOBJ ___setup_os ___PVOID;
extern void ___cleanup_os ___PVOID;


/* Utilities for machine encoding of characters. */

/*
 * For now a LATIN-1 encoding of characters is assumed for 'unsigned
 * char'.  This means that the mapping to and from the ISO/IEC
 * 10646-1:1993 character set is the identity function.  To support
 * other machine representations, e.g. EBCDIC, these macros would have
 * to actually translate the characters.
 */

#define ucs4_to_uchar(u)u
#define uchar_to_ucs4(c)c


/*---------------------------------------------------------------------------*/

#if 0



#if 1
#define USE_POSIX
#define USE_WIN32zzzzzzzz
#define USE_MACOSzzzzzzzz
#define USE_CURSES
#define USE_TERMINFOzzz
#define USE_TERMCAPzzzz

#define USE_gettimeofday
#define USE_select
#define USE_nanosleepzzzzzzzz

#else

#define USE_POSIXXXXXX
#define USE_WIN32
#define USE_MACOSzzzzzzzz
#define USE_CURSES
#define USE_TERMINFOzzz
#define USE_TERMCAPzzzz

#define USE_gettimeofdayXXXXXX
#define USE_selectXXXXXX
#define USE_MsgWaitForMultipleObjectsZZZZ /******************/
#define USE_nanosleepzzzzzzzz
#define USE_errnoXXXXXX
#define USE_GetLastError /**********************/
#define USE_WSAGetLastError /****************/

#endif


#ifdef INCLUDE_netdb_h
#define USE_h_errno
#ifndef sun////////////////////////////
#define USE_hstrerror
#endif
#endif




#include <stdlib.h>

#include <errno.h>


#ifdef USE_POSIX

#include <curses.h>

/*
MacOS X doesn't have this!
#include <term.h>
*/

#include <signal.h>
#include <sys/ioctl.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <sys/time.h>

#include <termios.h>
#include <unistd.h>

#include <termios.h>

#include <sys/socket.h>
#include <netinet/in.h>

#include <dirent.h>

#endif


#ifdef USE_WIN32

#include <winsock2.h>
#include <windows.h>
#include <tchar.h>
#include <sys/types.h>
#include <sys/timeb.h>

#undef COLOR_CYAN
#undef COLOR_BLUE
#define COLOR_CYAN 6
#define COLOR_BLUE 4

#endif


#endif /* #if 0 */


/*---------------------------------------------------------------------------*/

#endif
